$compile unit

$error all-
$lib all-

defint a-z

DECLARE SUB SETSYSTEMDATE(INTEGER,INTEGER,INTEGER,INTEGER)


' String Manipulation Routines 

'Ŀ
' SUBROUTINE CHKDATE(INPUT DATE,OUTPUT DATE,errcode%)                  
'    USED TO FORMAT AND CHECK A DATE                                   
'    ERRCODE% is true (-1) if any part of date is invalid.             
' MUST INCLUDE SETSYSTEMDATE                                           
'

SUB CHKDATE(INDATE$,OUTDATE$,ERRORDATE%) PUBLIC

	LOCAL SLASH,JK,J,JJ,RYEAR$,RYEAR%,RYEAR2$,RESETDATE$,Y%,M%,D%

	SLASH=0
	INDATE$=RTRIM$(INDATE$)
	JK=LEN(INDATE$)
	FOR J=1 TO JK
	IF SLASH=2 THEN EXIT FOR
	JJ=ASC(MID$(INDATE$,J,1))

'REPLACE ANY NON NUMBER WITH A "-"

	IF JJ < 48 OR JJ > 57 THEN
		INDATE$=LEFT$(INDATE$,J-1)+"-"+MID$(INDATE$,J+1,JK-J)
		INCR SLASH
	END IF
	NEXT J

'ADD 0 TO DAY, MONTH AND YEAR IF NEEDED

	IF MID$(INDATE$,2,1)="-" THEN INDATE$="0"+LEFT$(INDATE$,JK)
	IF MID$(INDATE$,5,1)="-" THEN INDATE$=LEFT$(INDATE$,3)+"0"+RIGHT$(INDATE$,LEN(INDATE$)-3)
	IF LEN(INDATE$)=7 THEN INDATE$=LEFT$(INDATE$,6)+"0"+RIGHT$(INDATE$,1)

'CHECK IF YEAR HAS 4 NUMBERS

	IF RIGHT$(INDATE$,2)<>RIGHT$(DATE$,2) THEN
		RYEAR$=RIGHT$(DATE$,4)
		RYEAR%=VAL(RYEAR$)-1
		RYEAR2$=STR$(RYEAR%)
		OUTDATE$=LEFT$(INDATE$,6)+MID$(RYEAR2$,2,2)+RIGHT$(INDATE$,2)
	ELSE
		OUTDATE$=LEFT$(INDATE$,6)+MID$(DATE$,7,2)+RIGHT$(INDATE$,2)
	END IF

	Y%=VAL(RIGHT$(OUTDATE$,4))
	M%=VAL(LEFT$(OUTDATE$,2))
	D%=VAL(MID$(OUTDATE$,4,2))

'GET SYSTEM DATE
	RESETDATE$=DATE$
	CALL SETSYSTEMDATE(Y%,M%,D%,ERRORD%)
	ERRORDATE%=ERRORD%

'PUT BACK SYSTEM DATE
	DATE$=RESETDATE$

END SUB