$compile unit

$error all-
$lib all-

defint a-z



'ReAttr - Recolor a given part of the screen
'Example - CALL ReAttr

SUB ReAttr(UpperRow%, LeftCol%, NumRows%, NumCols%, Atr%) PUBLIC
		!clc
		!push	ds
		!push	es
		!mov	ah,&h0F
		!int	&h10
		!cmp	al,7
		!jne	KolorCard
		!mov	bx,&HB000
		!mov	dx,&H3BA
		!jmp	short GetParameters
KolorCard:
		!mov	bx,&HB800
		!mov	dx,&H3DA

Getparameters:
		!push	bx
		!pop	es
		!lds	si,dword ptr [bp+&h0E]	; Load 32 bit ptr
		!mov	cx,[si]
		!push	cx
		!push	dx
		!xor	bx,bx			; Zero register
		!mov	bl,ah
		!push	bx
		!lds	si,dword ptr [bp+&h16]	; Load 32 bit ptr
		!mov	ax,[si]
		!dec	ax
		!mul	bx			; dx:ax = reg * ax
		!shl	ax,1			; Shift w/zeros fill
		!lds	si,dword ptr [bp+&h12]	; Load 32 bit ptr
		!mov	bx,[si]
		!dec	bx
		!shl	bx,1			; Shift w/zeros fill
		!add	bx,ax
		!mov	di,bx
		!lds	si,dword ptr [bp+6]	; Load 32 bit ptr
		!mov	ax,[si]
		!cld				; Clear direction
		!lds	si,dword ptr [bp+&H0A]	; Load 32 bit ptr
		!mov	si,[si]
			!pop	bx
		!shl	bx,1			; Shift w/zeros fill
		!pop	dx
loc3:
		!push	di
		!cli				; Disable interrupts
		!mov	cx,si
		!push	ax
loc4:
		!in	al,dx			; port 3DAh, CGA/EGA vid status
		!test	al,8
		!jnz	loc6			; Jump if not zero
		!rcr	al,1			; Rotate thru carry
		!jc	loc4			; Jump if carry Set
loc5:
		!in	al,dx			; port 3DAh, CGA/EGA vid status
		!rcr	al,1			; Rotate thru carry
		!jnc	loc5			; Jump if carry=0
loc6:
		!pop	ax

locloop7:
		!inc	di
		!stosb				; Store al to es:[di]
		!loop	locloop7		; Loop if cx > 0

		!sti				; Enable interrupts
		!pop	di
		!pop	cx
		!dec	cx
		!jcxz	loc8			; Jump if cx=0
		!push	cx
		!add	di,bx
		!jmp	short loc3		; (0156)
loc8:
		!pop	es
		!pop	ds
END SUB



SUB RECOLOR(oldattr%,Newattr%)   PUBLIC
		!push	ds
		!push	es
		!mov	ah,&h0F
		!int	&h10			; Video display   ah=functn 0Fh
		!cmp	al,7
		!jne	locc1			; Jump if not equal
		!mov	bx,&hB000
		!mov	dx,&h3BA
		!jmp	short locC2		; (011B)
locC1:
		!mov	bx,&hB800
		!mov	dx,&h3DA
locC2:
		!push	bx
		!pop	ds
		!mov	si,Newattr%		; (B800:0001=9)
		!les	di,dword ptr [bp+&h0A]	; Load 32 bit ptr
		!mov	cx,es:[di]
		!les	di,dword ptr [bp+6]	; Load 32 bit ptr
		!mov	bx,es:[di]
		!mov	bh,cl
		!mov	cx,&h7D0
		!mov	di,2
		!cld				; Clear direction
		!cli				; Disable interrupts

locCloop3:
		!in	al,dx			; port 3DAh, CGA/EGA vid status
		!shr	al,1			; Shift w/zeros fill
		!jc	locCloop3		; Jump if carry Set
locC4:
		!in	al,dx			; port 3DAh, CGA/EGA vid status
		!shr	al,1			; Shift w/zeros fill
		!jnc	locC4			; Jump if carry=0
		!cmp	[si],bh
		!jne	locC5			; Jump if not equal
		!mov	[si],bl
locC5:
		!add	si,di
		!loop	locCloop3		; Loop if cx > 0

		!sti				; Enable interrupts
		!pop	es
		!pop	ds
End sub