'Ŀ
'                    D I S K    F R E E    S P A C E    R T N               
'                                                                           
'    Previous versions by Robert Zale, Dave Navarro, et al.	             
'    Enhancements by Bard L. Kallestad  10/01/1993        		     
'    Changed again by James Jarvis                                          
'    1. Notice the changes in the SUB DiskFree.         	             
'    2. Using Double bytes ??(unsigned WORD) format for 16 bit values.      
'    3. Using Quad bytes  ???(unsigned DBL WORD) format for 32 bit values.  
'    4. Changed error check from carry bit to -1 on return of AX register   
'    5. Tested on 212 MB drive, appreciate feedback from anyone with 1 GB+  
'

'defint a-z

'Drive=3						'Set drive #
	                                                '1=A 2=B 3=C etc.
'CALL DiskFr3(Drive,tSPACE$,fSPACE$,TTSPACE&,FFSPACE&)	'Get Hard Drive parameters
        	                                        'Format drive information

'CLS	                                       'Printout info
'PRINT
'PRINT "Total Drive Space: "; TSPACE$,TTSPACE&
'PRINT "       Bytes Free: "; FSPACE$,FFSPACE&
'END
'============================================================================

$compile unit

$error all-
$lib all-

defint a-z

SUB DiskFr3(Drive,jtotal$,jfree$,jTTOTAL&,jFFREE&)   public

    REG 1, &H3600				' Setup function 36h
    REG 4, Drive                        	' Drive number
    CALL INTERRUPT &H21                 	' Do it

     Sectors.per.Cluster?? = BITS??(REG(1))
      Available.Clusters?? = BITS??(REG(2))
        Bytes.per.Sector?? = BITS??(REG(3))
    Total.Drive.Clusters?? = BITS??(REG(4))

    IF Sectors.Per.Cluster=&hFFFF THEN		'Errors?
       total.bytes???=0
       free.bytes???=0
       EXIT SUB
    END IF

			'Calculate total & free bytes
    Bytes.Per.Cluster???=Bytes.per.Sector??*Sectors.per.Cluster??
          Total.Bytes???=Total.Drive.Clusters??*Bytes.per.Cluster???
           Free.Bytes???=Available.Clusters??*Bytes.per.Cluster???


'CONVERT TO STRING AND LONG INTEGER

jTotal$=LTRIM$(USING$("############,",TOTAL.BYTES???))
jFree$=LTRIM$( USING$("############,",FREE.BYTES???))
jFree$=Space$(LEN(Total$)-LEN(jFree$))+jFree$
jTTOTAL&=VAL(REMOVE$(jTOTAL$,","))
jFFREE&=VAL(REMOVE$(jFREE$,","))

END SUB
